#!/bin/sh

set -e

ROOT=/usr/share/gallery
CONFDIR=/etc/gallery
SETUPDIR=/var/lib/gallery/setup

if [ `whoami` != "root" ] ; then
    echo "You must be root to run this script" 2>&1
    exit 1
fi

# Change perms back to being owned by root on the config files
for file in $CONFDIR/config.php $CONFDIR/htaccess; do
    if [ -s $file ] ; then
        chown root:root $file
    else
        # the file is 0 bytes, remove it as it didn't get written out
        rm -f $file
    fi
done

chmod 700 $ROOT/setup

echo ""
echo "Your Gallery is now secure and cannot be configured.  If"
echo "you wish to reconfigure it, run configure.sh as root:"
echo ""
echo "    # $ROOT/configure.sh"
echo ""
